#include<stdio.h>
#include <stdlib.h>

void print(int m, int n, int p, int q, float* a)
{
	int i,j;
	printf("\n");
	for(i=0; i<m; i++)
	{
		for(j=0; j<n; j++)
		{
			if((i==p-1)&&(j==q-1)) printf("[%.1f] ",*(a+i*n+j));
			else printf("%.1f ",*(a+i*n+j));
		}
		printf("\n");
	}
	printf("\n");
}

void exec_move(int m, int n, int* P, int *Q, float* a, float* Score)
{
	int p,q;
	float score;
	p = *P;
	q = *Q;
	score = *Score;
	float dirt = *(a+(p-1)*n+(q-1));
	if(dirt > 0)
	{
		score += dirt;
		*(a+(p-1)*n+(q-1)) = 0;
		printf("S %.1f\n",score);
		*Score = score;
		return;
	}
	if(p==1)
	{
		if(q==1)
		{
			if(rand()%2 == 0)
			{
				q++;
				printf("R %.1f\n",score);
				*Q = q;
			}
			else
			{
				p++;
				printf("D %.1f\n",score);
				*P = p;
			}
		}
		else if(q==n)
		{
			if(rand()%2 == 0)
			{
				q--;
				printf("L %.1f\n",score);
				*Q = q;
			}
			else
			{
				p++;
				printf("D %.1f\n",score);
				*P = p;
			}
		}
		else
		{
			int r = rand()%3;
			if(r == 0)
			{
				q--;
				printf("L %.1f\n",score);
				*Q = q;
			}
			else if(r == 1)
			{
				q++;
				printf("R %.1f\n",score);
				*Q = q;
			}
			else
			{
				p++;
				printf("D %.1f\n",score);
				*P = p;
			}
		}		
		return;
	}
	if(p==m)
	{
		if(q==1)
		{
			if(rand()%2 == 0)
			{
				q++;
				printf("R %.1f\n",score);
				*Q = q;
			}
			else
			{
				p--;
				printf("U %.1f\n",score);
				*P = p;
			}
		}
		else if(q==n)
		{
			if(rand()%2 == 0)
			{
				q--;
				printf("L %.1f\n",score);
				*Q = q;
			}
			else
			{
				p--;
				printf("U %.1f\n",score);
				*P = p;
			}
		}
		else
		{
			int r = rand()%3;
			if(r == 0)
			{
				q--;
				printf("L %.1f\n",score);
				*Q = q;
			}
			else if(r == 1)
			{
				q++;
				printf("R %.1f\n",score);
				*Q = q;
			}
			else
			{
				p--;
				printf("U %.1f\n",score);
				*P = p;
			}
		}		
		return;
	}
	if(q==1)
	{
		int r = rand()%3;
		if(r == 0)
		{
			p--;
			printf("U %.1f\n",score);
			*P = p;
		}
		else if(r == 1)
		{
			p++;
			printf("D %.1f\n",score);
			*P = p;
		}
		else
		{
			q++;
			printf("R %.1f\n",score);
			*Q = q;
		}
		return;
	}		
	if(q==n)
	{
		int r = rand()%3;
		if(r == 0)
		{
			p--;
			printf("U %.1f\n",score);
			*P = p;
		}
		else if(r == 1)
		{
			p++;
			printf("D %.1f\n",score);
			*P = p;
		}
		else
		{
			q--;
			printf("L %.1f\n",score);
			*Q = q;
		}
		return;
	}
	{
		int r = rand()%4;
		if(r == 0)
		{
			p--;
			printf("U %.1f\n",score);
			*P = p;
		}
		else if(r == 1)
		{
			p++;
			printf("D %.1f\n",score);
			*P = p;
		}
		else if(r == 2)
		{
			q--;
			printf("L %.1f\n",score);
			*Q = q;
		}
		else
		{
			q++;
			printf("R %.1f\n",score);
			*Q = q;
		}
		return;
	}
}

int main(int argc, char** argv)
{
	int m,n,max_moves,p,q;
	float *a;
	float score = 0;
	scanf("GRID: %d %d \n",&m ,&n);
	scanf("DIRT:\n");
	a = (float *) malloc(m*n*sizeof(float));

	int i,j;
	for(i=0; i<m; i++)
	{
		scanf("\t");
		for(j=0; j<n; j++)
		{
			scanf("%f ",(a+i*n+j));
		}
		scanf("\n");
	}

	scanf("MOVES: %d\n",&max_moves);
	scanf("INITIAL: %d %d\n",&p,&q);

	int current_move;

	for(current_move = 0; current_move < max_moves; current_move++)
	{
		if(current_move % 5 == 0) print(m,n,p,q,a);
		exec_move(m,n,&p,&q,a,&score);
	}
}
