#include<stdio.h>
#include <stdlib.h>

void print(int m, int n, int p, int q, float* a)
{
	int i,j;
	printf("\n");
	for(i=0; i<m; i++)
	{
		for(j=0; j<n; j++)
		{
			if((i==p-1)&&(j==q-1)) printf("[%.1f] ",*(a+i*n+j));
			else printf("%.1f ",*(a+i*n+j));
		}
		printf("\n");
	}
	printf("\n");
}

void exec_move(int m, int n, int* P, int *Q, float* a, float* Score)
{
	int p,q;
	float score;
	p = *P;
	q = *Q;
	score = *Score;
	float dirt = *(a+(p-1)*n+(q-1));
//	printf("p %d q %d dirt %.1f \n",p,q,dirt);
	if(dirt > 0)
	{
		score += dirt;
		*(a+(p-1)*n+(q-1)) = 0;
		printf("S %.1f\n",score);
		*Score = score;
		return;
	}
	int rem = -1;
	if(p==1)
	{
		if(q==1)
		{
			float d,r;	
			r = *(a+(p-1)*n+q);
			d = *(a+p*n+(q-1));
			
			if(r==d) rem = rand()%2;
//			printf("rem %d \n",rem);
			if((r > d)||(rem ==0))
			{
				q++;
				printf("R %.1f\n",score);
				*Q = q;
			}
			else
			{
				p++;
				printf("D %.1f\n",score);
				*P = p;
			}
		}
		else if(q==n)
		{
			float d,l;	
			l = *(a+(p-1)*n+(q-2));
			d = *(a+p*n+(q-1));

			if(l==d) rem = rand()%2;
//			printf("rem %d \n",rem);
			if((l > d)||(rem==0))
			{
				q--;
				printf("L %.1f\n",score);
				*Q = q;
			}
			else
			{
				p++;
				printf("D %.1f\n",score);
				*P = p;
			}
		}
		else
		{
			float d,r,l;	
			r = *(a+ (p-1)*n + q);
			d = *(a+p*n+(q-1));
			l = *(a+(p-1)*n+(q-2));

			if((r==d)&&(d==l)) rem = rand()%3;
//			printf("rem %d \n",rem);
			if(((l>r) && (l>d))||(rem==0))
			{
				q--;
				printf("L %.1f\n",score);
				*Q = q;
			}
			else if(((r>l)&&(r>d))||(rem==1))
			{
				q++;
				printf("R %.1f\n",score);
				*Q = q;
			}
			else
			{
				p++;
				printf("D %.1f\n",score);
				*P = p;
			}
		}		
		return;
	}
	if(p==m)
	{
		if(q==1)
		{
			float r,u;	
			r = *(a+(p-1)*n+q);
			u = *(a+(p-2)*n+(q-1));

			if(r==u) rem = rand()%2;
//			printf("rem %d \n",rem);
			if((r>u)||(rem==0))
			{
				q++;
				printf("R %.1f\n",score);
				*Q = q;
			}
			else
			{
				p--;
				printf("U %.1f\n",score);
				*P = p;
			}
		}
		else if(q==n)
		{
			float l,u;	
			l = *(a+(p-1)*n+(q-2));
			u = *(a+(p-2)*n+(q-1));

			if(l==u) rem = rand()%2;
//			printf("rem %d \n",rem);
			if((l>u)||(rem==0))
			{
				q--;
				printf("L %.1f\n",score);
				*Q = q;
			}
			else
			{
				p--;
				printf("U %.1f\n",score);
				*P = p;
			}
		}
		else
		{
			float u,r,l;	
			r = *(a+(p-1)*n+q);
			u = *(a+(p-2)*n+(q-1));
			l = *(a+(p-1)*n+(q-2));

			if((r==u)&&(u==l)) rem = rand()%3;
//			printf("rem %d \n",rem);
			if(((l>r)&&(l>u))||(rem==0))
			{
				q--;
				printf("L %.1f\n",score);
				*Q = q;
			}
			else if(((r>l)&&(r>u))||(rem==1))
			{
				q++;
				printf("R %.1f\n",score);
				*Q = q;
			}
			else
			{
				p--;
				printf("U %.1f\n",score);
				*P = p;
			}
		}		
		return;
	}
	if(q==1)
	{
		float d,r,u;	
		r = *(a+(p-1)*n+q);
		d = *(a+p*n+(q-1));
		u = *(a+(p-2)*n+(q-1));

		if((r==d)&&(d==u)) rem = rand()%3;
//		printf("rem %d \n",rem);
		if(((u>d)&&(u>r))||(rem==0))
		{
			p--;
			printf("U %.1f\n",score);
			*P = p;
		}
		else if(((d>u)&&(d>r))||(rem==1))
		{
			p++;
			printf("D %.1f\n",score);
			*P = p;
		}
		else
		{
			q++;
			printf("R %.1f\n",score);
			*Q = q;
		}
		return;
	}		
	if(q==n)
	{
		float d,u,l;	
		l = *(a+(p-1)*n+(q-2));
		d = *(a+p*n+(q-1));
		u = *(a+(p-2)*n+(q-1));

		if((l==d)&&(d==u)) rem = rand()%3;
//		printf("rem %d \n",rem);
		if(((u>d)&&(u>l))||(rem==0))
		{
			p--;
			printf("U %.1f\n",score);
			*P = p;
		}
		else if(((d>u)&&(d>l))||(rem==1))
		{
			p++;
			printf("D %.1f\n",score);
			*P = p;
		}
		else
		{
			q--;
			printf("L %.1f\n",score);
			*Q = q;
		}
		return;
	}
	{
		float d,r,l,u;	
		r = *(a+(p-1)*n+q);
		d = *(a+p*n+(q-1));
		u = *(a+(p-2)*n+(q-1));
		l = *(a+(p-1)*n+(q-2));

		if((r==d)&&(d==u)&&(u==l)) rem = rand()%4;
//		printf("rem %d \n",rem);
		if(((u>d)&&(u>l)&&(u>r))||(rem==0))
		{
			p--;
			printf("U %.1f\n",score);
			*P = p;
		}
		else if(((d>u)&&(d>l)&&(d>r))||(rem==1))
		{
			p++;
			printf("D %.1f\n",score);
			*P = p;
		}
		else if(((l>u)&&(l>d)&&(l>r))||(rem==2))
		{
			q--;
			printf("L %.1f\n",score);
			*Q = q;
		}
		else
		{
			q++;
			printf("R %.1f\n",score);
			*Q = q;
		}
		return;
	}
}

int main(int argc, char** argv)
{
	int m,n,max_moves,p,q;
	float *a;
	float score = 0;
	scanf("GRID: %d %d \n",&m ,&n);
	scanf("DIRT:\n");
	a = (float *) malloc(m*n*sizeof(float));

	int i,j;
	for(i=0; i<m; i++)
	{
		scanf("\t");
		for(j=0; j<n; j++)
		{
			scanf("%f ",(a+i*n+j));
		}
		scanf("\n");
	}

	scanf("MOVES: %d\n",&max_moves);
	scanf("INITIAL: %d %d\n",&p,&q);

	int current_move;

	for(current_move = 0; current_move < max_moves; current_move++)
	{
		if(current_move % 5 == 0) print(m,n,p,q,a);
//		print(m,n,p,q,a);
		exec_move(m,n,&p,&q,a,&score);
	}
}
