#include<stdio.h>
#include <stdlib.h>

long glo;

struct step {
	char s;
	int from_p,to_p,from_q,to_q;
	struct step* before;
	struct step* after;
};

void print(int m, int n, int p, int q, float* a)
{
	int i,j;
	printf("\n");
	for(i=0; i<m; i++)
	{
		for(j=0; j<n; j++)
		{
			if(*(a+i*n+j)<0) 
			{
				if((i==p-1)&&(j==q-1)) printf("[ ?]\t");
				else printf("  ?\t");
			}
			else 
			{
				if((i==p-1)&&(j==q-1)) printf("[%.1f]\t",*(a+i*n+j));
				else printf("%.1f\t",*(a+i*n+j));
			}
		}
		printf("\n");
	}
	printf("\n");
}

float find_moves(int m, int n, int v_m1,int v_n1,int v_m2,int v_n2,int p,int q,float* b,int moves_left,struct step *path)
{
//printf("moves_left %d\n",moves_left);
	glo++;

	if((p<v_m1)||(q<v_n1)||(p>v_m2)||(q>v_n2)) return -1;		// if out of border
	if(moves_left==0) {path=NULL;return 0;}						// out of steps
	if(moves_left<0) {path=NULL;return 0;}
//	if(moves_left==1) {*path='S'; return *(b+(p-1)*n+(q-1));}	// last step

	float *a;
	a = (float *) malloc(m*n*sizeof(float));
	int i,j;
	for(i=0; i<m; i++)
	{
		for(j=0; j<n; j++)
		{
			*(a+i*n+j)=*(b+i*n+j);
		}
	}

	struct step* final;
	int pointer = 1;
	float dirt,result;
	result = 0;
	dirt = *(a+(p-1)*n+(q-1));
//	if(dirt<0) dirt = 0;

			float r1,d1,r2,d2,l1,u1,l2,u2;
			struct step *pr1,*pd1,*pr2,*pd2,*pl1,*pu1,*pl2,*pu2;
			
			pr1 = (struct step *)malloc(sizeof(struct step));
			r1 = find_moves(m, n, v_m1, v_n1, v_m2, v_n2, p, q+1, a, moves_left-1,pr1);

			pd1 = (struct step *)malloc(sizeof(struct step));
			d1 = find_moves(m, n, v_m1, v_n1, v_m2, v_n2, p+1, q, a, moves_left-1,pd1);

			pl1 = (struct step *)malloc(sizeof(struct step));
			l1 = find_moves(m, n, v_m1, v_n1, v_m2, v_n2, p, q-1, a, moves_left-1,pl1);	

			pu1 = (struct step *)malloc(sizeof(struct step));
			u1 = find_moves(m, n, v_m1, v_n1, v_m2, v_n2, p-1, q, a, moves_left-1,pu1);

			*(a+(p-1)*n+(q-1)) = 0;

			pr2 = (struct step *)malloc(sizeof(struct step));
			r2 = dirt + find_moves(m, n, v_m1, v_n1, v_m2, v_n2, p, q+1, a, moves_left-2,pr2);

			pd2 = (struct step *)malloc(sizeof(struct step));
			d2 = dirt + find_moves(m, n, v_m1, v_n1, v_m2, v_n2, p+1, q, a, moves_left-2,pd2);

			pl2 = (struct step *)malloc(sizeof(struct step));
			l2 = dirt + find_moves(m, n, v_m1, v_n1, v_m2, v_n2, p, q-1, a, moves_left-2,pl2);

			pu2 = (struct step *)malloc(sizeof(struct step));
			u2 = dirt + find_moves(m, n, v_m1, v_n1, v_m2, v_n2, p-1, q, a, moves_left-2,pu2);				

			if(r1>result) 
			{
				path->s = 'R';
				path->to_p = p ;
				path->to_q = q+1;
				pointer = 1;
				final = pr1;
				result = r1;
			}
			if(d1>result) 
			{
				path->s = 'D';
				path->to_p = p+1 ;
				path->to_q = q;
				pointer = 1;
				final = pd1;
				result = d1;
			}
			if(l1>result) 
			{
				path->s = 'L';
				path->to_p = p ;
				path->to_q = q-1;
				pointer = 1;
				final = pl1;
				result = l1;
			}
			if(u1>result) 
			{
				path->s = 'U';
				path->to_p = p-1;
				path->to_q = q;
				pointer = 1;
				final = pu1;
				result = u1;
			}
			if(r2>result) 
			{
				path->s = 'S';
				path->to_p = p ;
				path->to_q = q;
				if(moves_left>1)
				{
					path->after = (struct step *)malloc(sizeof(struct step));
					(path->after)->s = 'R';
					(path->after)->to_p = p ;
					(path->after)->to_q = q+1;
					pointer = 2;
				}
				result = r2;
				final = pr2;
			}
			if(d2>result) 
			{
				path->s = 'S';
				path->to_p = p ;
				path->to_q = q;
				if(moves_left>1)
				{
					path->after = (struct step *)malloc(sizeof(struct step));
					(path->after)->s = 'D';
					(path->after)->to_p = p+1 ;
					(path->after)->to_q = q;
					pointer = 2;
				}
				result = d2;
				final = pd2;
			}
			if(l2>result) 
			{
				path->s = 'S';
				path->to_p = p ;
				path->to_q = q;
				if(moves_left>1)
				{
					path->after = (struct step *)malloc(sizeof(struct step));
					(path->after)->s = 'L';
					(path->after)->to_p = p;
					(path->after)->to_q = q-1;
					pointer = 2;
				}
				result = l2;
				final = pl2;
			}
			if(u2>result) 
			{
				path->s = 'S';
				path->to_p = p ;
				path->to_q = q;
				if(moves_left>1)
				{
					path->after = (struct step *)malloc(sizeof(struct step));
					(path->after)->s = 'U';
					(path->after)->to_p = p-1;
					(path->after)->to_q = q;
					pointer = 2;
				}
				result = u2;
				final = pu2;
			}

			path->from_p = p; path->from_q = q;

			if(pointer==1) { path->after = final;}
			if(pointer==2) { (path->after)->after = final;}

			return result;
}

void check(int m,int n,int p,int q,float* v,int done,int* Allowed_moves,int max_moves,struct step* path,float* Assured_score)
{
	int allowed_moves = *Allowed_moves;
	float assured_score = *Assured_score;

	struct step* curr;
	curr = path;

	int k = done; int y=0;
	while(k < allowed_moves)
	{
		if((curr->from_p == p)&&(curr->from_q == q)&&(curr->s == 'S')) return;
		if((curr->from_p == p)&&(curr->from_q == q)&&(curr->s != 'S')) y=k;
		curr = curr->after;
		k++;		
	}
	if(y >= done)
	{
		k=done;
		curr = path;
		while(k < y-1)
		{
			curr = curr->after;
			k++;		
		}
		struct step* new;
		new = (struct step *)malloc(sizeof(struct step));
		*new = *(curr->after);
		new->after = curr->after;
		new->s = 'S';
		new->to_p = new->from_p; new->to_q = new->from_q;
		curr->after = new;
		assured_score += *(v+(p-1)*n+(q-1));
		allowed_moves++;
		*Allowed_moves = allowed_moves;
		*Assured_score = assured_score;
		return; 
	}
/*
	if(max_moves-allowed_moves < 3) return;

	k=done; y=0; char c;
	while(k < allowed_moves)
	{
		if((curr->to_p == p-1)&&(curr->to_q == q)) {y=k; c='D';break;}
		if((curr->to_p == p)&&(curr->to_q == q-1)) {y=k; c='R';break;}		
		if((curr->to_p == p)&&(curr->to_q == q+1)) {y=k; c='L';break;}
		if((curr->to_p == p+1)&&(curr->to_q == q)) {y=k; c='U';break;}
		curr = curr->after;
		k++;		
	}
	if(y >= done)
	{
		k=done;
		curr = path;
		while(k < y)
		{
			curr = curr->after;
			k++;		
		}
		struct step *new,*new2,*new3;
		new = (struct step *)malloc(sizeof(struct step));
		new2 = (struct step *)malloc(sizeof(struct step));
		new3 = (struct step *)malloc(sizeof(struct step));

		new->s = c;
		new->from_p = (curr->after)->from_p; new->from_q = (curr->after)->from_q;
		new->to_p = p; new->to_q = q;

		new2->s = 'S';
		new2->from_p = p; new2->from_q = q;
		new2->to_p = p; new2->to_q = q;

		if(c=='D') new3->s='U';
		if(c=='U') new3->s='D';
		if(c=='R') new3->s='L';
		if(c=='L') new3->s='R';
		new3->from_p = p; new3->from_q = q;
		new3->to_p = new->from_p ; new3->to_q = new->from_q;

		new3->after = curr->after;
		new2->after = new3;
		new->after = new2;
		curr->after = new;

		assured_score += *(v+(p-1)*n+(q-1));
		allowed_moves += 3;
		*Allowed_moves = allowed_moves;
		*Assured_score = assured_score;
		return; 
	}	*/
}

void exec_move(int m,int n,int v_m1,int v_n1,int v_m2,int v_n2,int p,int q,float* a,float* v,int max_moves)
{
	float assured_score = 0;
	float score = 0;
//	float dirt = *(a+(p-1)*n+(q-1));

	struct step* path;
	path = (struct step *) malloc(sizeof(struct step));

	int allowed_moves = 6;
	if(v_m2-v_m1 == 2) allowed_moves += 3;
	if(v_n2-v_n1 == 2) allowed_moves += 3;

	assured_score = find_moves(m, n, v_m1, v_n1, v_m2, v_n2, p, q, v, allowed_moves, path);
	printf("%ld \n",glo);
	printf("assured_score %.1f\n",assured_score);
	glo = 0;

	struct step* curr;
	curr = path;

	int k=0;
	while(k < allowed_moves)
	{
		if(curr->s == 'S') 
		{	
			score += *(a+(p-1)*n+(q-1)); 
			*(a+(p-1)*n+(q-1)) = 0;
			*(v+(p-1)*n+(q-1)) = 0;
		}
		else
		{
			p = curr->to_p;
			q = curr->to_q;
			v_m1 = p ; v_m2 = p; v_n1 = q; v_n2 = q;
			if(p!=1)	
			{
				if(*(v+(p-2)*n+(q-1)) == -1)
				{
					*(v+(p-2)*n+(q-1)) = *(a+(p-2)*n+(q-1));
					if(allowed_moves < max_moves)
					check(m,n,p-1,q,v,k,&allowed_moves,max_moves,curr,&assured_score);
				}
				if(v_m1 > p-1) v_m1 = p-1;
			}
			if(q!=1)
			{
				if(*(v+(p-1)*n+(q-2)) == -1)
				{
					*(v+(p-1)*n+(q-2)) = *(a+(p-1)*n+(q-2));
					if(allowed_moves < max_moves)
					check(m,n,p,q-1,v,k,&allowed_moves,max_moves,path,&assured_score);
				}
				 if(v_n1 > q-1) v_n1 = q-1;
			}
			if(p!=m)
			{
				if(*(v+p*n+(q-1)) ==-1)
				{
					*(v+p*n+(q-1)) = *(a+p*n+(q-1)); 
					if(allowed_moves < max_moves)
					check(m,n,p+1,q,v,k,&allowed_moves,max_moves,path,&assured_score);
				}
				if(v_m2 < p+1) v_m2 = p+1;
			}
			if(q!=n)
			{
				if(*(v+(p-1)*n+q) == -1)
				{
					*(v+(p-1)*n+q) = *(a+(p-1)*n+q);
					if(allowed_moves < max_moves)
					check(m,n,p,q+1,v,k,&allowed_moves,max_moves,path,&assured_score);
				}
				if(v_n2 < q+1) v_n2 = q+1;
			}
		}
		printf("%c %.1f\n",curr->s,score);
		print(m, n, p, q, v);
		curr = curr->after;
		k++;
	}
	printf("\n");
	printf("score %.1f\n",score);
	print(m, n, p, q, v);
}

int main(int argc, char** argv)
{
	glo =0;
	int m,n,max_moves,p,q,v_m1,v_n1,v_m2,v_n2;
	float *a, *v;

	scanf("GRID: %d %d \n",&m ,&n);
	scanf("DIRT:\n");
	a = (float *) malloc(m*n*sizeof(float));
	v = (float *) malloc(m*n*sizeof(float));

	int i,j;
	for(i=0; i<m; i++)
	{
		scanf("\t");
		for(j=0; j<n; j++)
		{
			scanf("%f ",(a+i*n+j));
			*(v+i*n+j) = -1;
		}
		scanf("\n");
	}

	scanf("MOVES: %d\n",&max_moves);
	scanf("INITIAL: %d %d\n",&p,&q);

	*(v+(p-1)*n+(q-1)) = *(a+(p-1)*n+(q-1));
	v_m1 = p ; v_m2 = p; v_n1 = q; v_n2 = q;
	if(p!=1)	{*(v+(p-2)*n+(q-1)) = *(a+(p-2)*n+(q-1)); v_m1 = p-1;}
	if(q!=1)	{*(v+(p-1)*n+(q-2)) = *(a+(p-1)*n+(q-2)); v_n1 = q-1;}
	if(p!=m)	{*(v+p*n+(q-1)) = *(a+p*n+(q-1)); v_m2 = p+1;}
	if(q!=n)	{*(v+(p-1)*n+q) = *(a+(p-1)*n+q); v_n2 = q+1;}

	print(m, n, p, q, v);

	exec_move(m,n,v_m1,v_n1,v_m2,v_n2,p,q,a,v,max_moves);

}

